use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.

$YappProg = 'yapp';
$YappArgs = '-v -s';

sub MY::depend {
  return
    (''
     # dist requires current README
     .qq(dist : README\n\n)
    );
}

sub MY::postamble {
  return
    (''
     # format the README file
     .qq(README : README.pod\n)
     .qq(\t pod2text README.pod > README\n\n)

     # build the parse
     .qq(SayWhat/Parser.pm: SayWhat/Parser.yp\n)
     .qq(\t$YappProg $YappArgs -m SayWhat::Parser -o \$@ \$<\n\n)
    );
}

WriteMakefile(
	      NAME	=> 'SayWhat',
	      AUTHOR    => 'Bryan Jurish <moocow@ling.uni-potsdam.de>',
	      ABSTRACT  => 'Produce nonsense to the dsp using Speech::* synthesis modules',
	      VERSION_FROM => 'SayWhat/Base.pm', # finds $VERSION
	      EXE_FILES => [qw(saywhat.perl)],
	      PREREQ_PM => {
			    Speech::Festival => 0,  # 'speech_pm_1.0'
			    Speech::Rsynth => 0.02, # 0.02
			    Pd::Socket => 0,        # 0.01
			    Audio::Wav => 0.02,     # 0.02
			    Parse::Lex => 0,        # 2.15
			    #Parse::Yapp => 0,      # 1.03
			    Tk => 0,                # 800.023
			    Storable => 0,          # 1.013
			    OSC => 0.03,
			   },
	      PM => {
		     map { ($_ => "\$(INST_LIBDIR)/$_") }
		     qw(SayWhat/Base.pm
			SayWhat/Tk.pm
			SayWhat/PD.pm
			SayWhat/OSC.pm
			SayWhat/LexWrapper.pm
			SayWhat/Parser.pm
			SayWhat/Synthesizer.pm
			SayWhat/Synthesizer/Festival.pm
			SayWhat/Synthesizer/Rsynth.pm
			Grammar/Tree.pm
			Grammar/ContextFree/Generator.pm)
		    },
	     );
