####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package SayWhat::Parser;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 17 "SayWhat/Parser.yp"

    package SayWhat::Parser;
    use SayWhat::Base;
    sub yywarn {
      defined($_[0]->YYData->{LexWrapper})
	? $_[0]->YYData->{LexWrapper}->yywarn(@_[1..$#_])
	: print STDERR "Warning: ", @_[1..$#_], "\n";
    }
    #print STDERR "SayWhat::Parser loading...\n";


sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'HELP' => 1,
			'GENERATE' => 13,
			'SEMICOLON' => -7,
			'LL_UTTS' => 14,
			'LOAD_RULES' => 3,
			'BYE' => 2,
			'STORE_GRAMMAR' => 16,
			'SAVE_SCRIPT' => 15,
			'SAVE_UTT' => 5,
			'error' => 19,
			'GENERATE_SAY' => 18,
			'LOAD_GRAMMAR' => 6,
			'EOF' => -7,
			'SYNTH_CONF' => 20,
			'SYNTH' => 7,
			'EVAL_PERL' => 24,
			'ADD_UTT' => 23,
			'SAY' => 22,
			'SET_WBOUND' => 8,
			'FORGET_GRAMMAR' => 9,
			'MAX_EXPANSIONS' => 28,
			'LS_UTTS' => 27,
			'DEL_UTT' => 26,
			'LOAD_SCRIPT' => 11,
			'RENAME_UTT' => 10,
			'NEWLINE' => -7,
			'RETR_GRAMMAR' => 30,
			'SYNTH_TYPE' => 29,
			'GENERATE_TO' => 12
		},
		GOTOS => {
			'command_body' => 21,
			'command' => 25,
			'system_cmd' => 4,
			'command_seq' => 17
		}
	},
	{#State 1
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -10,
		GOTOS => {
			'string' => 31
		}
	},
	{#State 2
		DEFAULT => -48
	},
	{#State 3
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 34
		}
	},
	{#State 4
		DEFAULT => -8
	},
	{#State 5
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 37
		}
	},
	{#State 6
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 38
		}
	},
	{#State 7
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 39
		}
	},
	{#State 8
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 40
		}
	},
	{#State 9
		DEFAULT => -23
	},
	{#State 10
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 41
		}
	},
	{#State 11
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 42
		}
	},
	{#State 12
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -29,
		GOTOS => {
			'string' => 36,
			'id' => 43
		}
	},
	{#State 13
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -25,
		GOTOS => {
			'string' => 36,
			'nonterm' => 44,
			'id' => 45
		}
	},
	{#State 14
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -37,
		GOTOS => {
			'string' => 36,
			'id' => 46
		}
	},
	{#State 15
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 47
		}
	},
	{#State 16
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 48
		}
	},
	{#State 17
		ACTIONS => {
			'' => 49,
			'HELP' => 1,
			'LOAD_RULES' => 3,
			'BYE' => 2,
			'SAVE_UTT' => 5,
			'LOAD_GRAMMAR' => 6,
			'SYNTH' => 7,
			'SET_WBOUND' => 8,
			'FORGET_GRAMMAR' => 9,
			'LOAD_SCRIPT' => 11,
			'RENAME_UTT' => 10,
			'NEWLINE' => -7,
			'GENERATE_TO' => 12,
			'GENERATE' => 13,
			'SEMICOLON' => -7,
			'LL_UTTS' => 14,
			'SAVE_SCRIPT' => 15,
			'STORE_GRAMMAR' => 16,
			'error' => 19,
			'GENERATE_SAY' => 18,
			'EOF' => -7,
			'SYNTH_CONF' => 20,
			'EVAL_PERL' => 24,
			'ADD_UTT' => 23,
			'SAY' => 22,
			'MAX_EXPANSIONS' => 28,
			'LS_UTTS' => 27,
			'DEL_UTT' => 26,
			'SYNTH_TYPE' => 29,
			'RETR_GRAMMAR' => 30
		},
		GOTOS => {
			'command_body' => 21,
			'command' => 50,
			'system_cmd' => 4
		}
	},
	{#State 18
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -27,
		GOTOS => {
			'string' => 36,
			'nonterm' => 51,
			'id' => 45
		}
	},
	{#State 19
		DEFAULT => -9
	},
	{#State 20
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -16,
		GOTOS => {
			'string' => 36,
			'config_list' => 52,
			'id' => 53
		}
	},
	{#State 21
		ACTIONS => {
			'EOF' => 57,
			'SEMICOLON' => 56,
			'NEWLINE' => 54
		},
		GOTOS => {
			'command_end' => 55
		}
	},
	{#State 22
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 58
		}
	},
	{#State 23
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 59
		}
	},
	{#State 24
		ACTIONS => {
			'LBRACE' => 61
		},
		GOTOS => {
			'perl_block' => 60
		}
	},
	{#State 25
		DEFAULT => -1
	},
	{#State 26
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 62
		}
	},
	{#State 27
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -35,
		GOTOS => {
			'string' => 36,
			'id' => 63
		}
	},
	{#State 28
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 64
		}
	},
	{#State 29
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -14,
		GOTOS => {
			'string' => 36,
			'id' => 65
		}
	},
	{#State 30
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 66
		}
	},
	{#State 31
		DEFAULT => -11
	},
	{#State 32
		DEFAULT => -54
	},
	{#State 33
		DEFAULT => -55
	},
	{#State 34
		DEFAULT => -21
	},
	{#State 35
		DEFAULT => -51
	},
	{#State 36
		DEFAULT => -52
	},
	{#State 37
		ACTIONS => {
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -44,
		GOTOS => {
			'string' => 67
		}
	},
	{#State 38
		DEFAULT => -19
	},
	{#State 39
		DEFAULT => -43
	},
	{#State 40
		DEFAULT => -24
	},
	{#State 41
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 68
		}
	},
	{#State 42
		DEFAULT => -12
	},
	{#State 43
		DEFAULT => -30
	},
	{#State 44
		DEFAULT => -26
	},
	{#State 45
		DEFAULT => -53
	},
	{#State 46
		DEFAULT => -36
	},
	{#State 47
		DEFAULT => -13
	},
	{#State 48
		DEFAULT => -22
	},
	{#State 49
		DEFAULT => -0
	},
	{#State 50
		DEFAULT => -2
	},
	{#State 51
		DEFAULT => -28
	},
	{#State 52
		ACTIONS => {
			'COMMA' => 69
		},
		DEFAULT => -18
	},
	{#State 53
		ACTIONS => {
			'EQUAL' => 70
		},
		DEFAULT => -17
	},
	{#State 54
		DEFAULT => -5
	},
	{#State 55
		DEFAULT => -3
	},
	{#State 56
		DEFAULT => -4
	},
	{#State 57
		DEFAULT => -6
	},
	{#State 58
		DEFAULT => -47
	},
	{#State 59
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -38,
		GOTOS => {
			'string' => 71,
			'id' => 72
		}
	},
	{#State 60
		DEFAULT => -33
	},
	{#State 61
		DEFAULT => -56,
		GOTOS => {
			'@1-1' => 73
		}
	},
	{#State 62
		DEFAULT => -42
	},
	{#State 63
		DEFAULT => -34
	},
	{#State 64
		DEFAULT => -32
	},
	{#State 65
		DEFAULT => -15
	},
	{#State 66
		DEFAULT => -20
	},
	{#State 67
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -45,
		GOTOS => {
			'string' => 36,
			'id' => 74
		}
	},
	{#State 68
		DEFAULT => -41
	},
	{#State 69
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 75
		}
	},
	{#State 70
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 76
		}
	},
	{#State 71
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		DEFAULT => -52,
		GOTOS => {
			'string' => 36,
			'id' => 77
		}
	},
	{#State 72
		DEFAULT => -39
	},
	{#State 73
		DEFAULT => -58,
		GOTOS => {
			'block_body' => 78
		}
	},
	{#State 74
		DEFAULT => -46
	},
	{#State 75
		ACTIONS => {
			'EQUAL' => 79
		}
	},
	{#State 76
		DEFAULT => -49
	},
	{#State 77
		DEFAULT => -40
	},
	{#State 78
		ACTIONS => {
			'RBRACE' => 82,
			'PERL_CODE' => 81,
			'LBRACE' => 61
		},
		GOTOS => {
			'perl_block' => 80
		}
	},
	{#State 79
		ACTIONS => {
			'SYMBOL' => 35,
			'SQ_STRING' => 33,
			'DQ_STRING' => 32
		},
		GOTOS => {
			'string' => 36,
			'id' => 83
		}
	},
	{#State 80
		DEFAULT => -60
	},
	{#State 81
		DEFAULT => -59
	},
	{#State 82
		DEFAULT => -57
	},
	{#State 83
		DEFAULT => -50
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'command_seq', 1, undef
	],
	[#Rule 2
		 'command_seq', 2, undef
	],
	[#Rule 3
		 'command', 2,
sub
#line 35 "SayWhat/Parser.yp"
{
  my $rc = ref($_[1]) eq 'CODE' ? &{$_[1]}(@_) : $_[1];
  $_[0]->YYData->{SayWhat}->doprompt($_[0]->YYData->{LexWrapper});
  $rc;
  }
	],
	[#Rule 4
		 'command_end', 1, undef
	],
	[#Rule 5
		 'command_end', 1, undef
	],
	[#Rule 6
		 'command_end', 1, undef
	],
	[#Rule 7
		 'command_body', 0, undef
	],
	[#Rule 8
		 'command_body', 1,
sub
#line 48 "SayWhat/Parser.yp"
{ $_[1] }
	],
	[#Rule 9
		 'command_body', 1, undef
	],
	[#Rule 10
		 'system_cmd', 1,
sub
#line 54 "SayWhat/Parser.yp"
{ &main::help() }
	],
	[#Rule 11
		 'system_cmd', 2,
sub
#line 55 "SayWhat/Parser.yp"
{ &main::help($_[2]) }
	],
	[#Rule 12
		 'system_cmd', 2,
sub
#line 56 "SayWhat/Parser.yp"
{
    my $filename = $_[2];
    my $fh = FileHandle->new("<$filename");
    sub {
      if (!defined($fh)) {
	$_[0]->yywarn("open failed for script-file `$filename': $!");
      } else {
	$_[0]->YYData->{LexWrapper}->recurse($fh,$filename);
      }
    }
  }
	],
	[#Rule 13
		 'system_cmd', 2,
sub
#line 67 "SayWhat/Parser.yp"
{
    $_[0]->YYData->{SayWhat}->save_script($_[2]) ||
      $_[0]->yywarn("error saving to file `$_[2]': $!");
  }
	],
	[#Rule 14
		 'system_cmd', 1,
sub
#line 73 "SayWhat/Parser.yp"
{ print $_[0]->YYData->{SayWhat}->synth_type(), "\n"; }
	],
	[#Rule 15
		 'system_cmd', 2,
sub
#line 74 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->synth_type($_[2]) }
	],
	[#Rule 16
		 'system_cmd', 1,
sub
#line 75 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->show_synth_config() }
	],
	[#Rule 17
		 'system_cmd', 2,
sub
#line 76 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->show_synth_config($_[2]) }
	],
	[#Rule 18
		 'system_cmd', 2,
sub
#line 77 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->synth_config(@{$_[2]}) }
	],
	[#Rule 19
		 'system_cmd', 2,
sub
#line 80 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->load_grammar($_[2],'auto') }
	],
	[#Rule 20
		 'system_cmd', 2,
sub
#line 81 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->load_grammar($_[2],'sto') }
	],
	[#Rule 21
		 'system_cmd', 2,
sub
#line 82 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->load_grammar($_[2],'rule') }
	],
	[#Rule 22
		 'system_cmd', 2,
sub
#line 83 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->store_grammar($_[2]) }
	],
	[#Rule 23
		 'system_cmd', 1,
sub
#line 84 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->forget_grammar }
	],
	[#Rule 24
		 'system_cmd', 2,
sub
#line 86 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->wbound($_[2]) }
	],
	[#Rule 25
		 'system_cmd', 1,
sub
#line 87 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate() }
	],
	[#Rule 26
		 'system_cmd', 2,
sub
#line 88 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate($_[2]) }
	],
	[#Rule 27
		 'system_cmd', 1,
sub
#line 89 "SayWhat/Parser.yp"
{  $_[0]->YYData->{SayWhat}->generate_say() }
	],
	[#Rule 28
		 'system_cmd', 2,
sub
#line 90 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate_say($_[2]) }
	],
	[#Rule 29
		 'system_cmd', 1,
sub
#line 91 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate_to() }
	],
	[#Rule 30
		 'system_cmd', 2,
sub
#line 92 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate_to($_[2]) }
	],
	[#Rule 31
		 'system_cmd', 2,
sub
#line 93 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->generate_to($_[2],$_[3]) }
	],
	[#Rule 32
		 'system_cmd', 2,
sub
#line 94 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}{grammar}->maxexpansions($_[2]) }
	],
	[#Rule 33
		 'system_cmd', 2,
sub
#line 96 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->eval_perl($_[2]) }
	],
	[#Rule 34
		 'system_cmd', 2,
sub
#line 98 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->ls_utterances($_[2]) }
	],
	[#Rule 35
		 'system_cmd', 1,
sub
#line 99 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->ls_utterances() }
	],
	[#Rule 36
		 'system_cmd', 2,
sub
#line 100 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->ll_utterances($_[2]) }
	],
	[#Rule 37
		 'system_cmd', 1,
sub
#line 101 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->ll_utterances() }
	],
	[#Rule 38
		 'system_cmd', 2,
sub
#line 103 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->add_utterance($_[2]) }
	],
	[#Rule 39
		 'system_cmd', 3,
sub
#line 104 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->add_utterance($_[2],$_[3]) }
	],
	[#Rule 40
		 'system_cmd', 4,
sub
#line 105 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->add_utterance($_[2],$_[3],$_[4]) }
	],
	[#Rule 41
		 'system_cmd', 3,
sub
#line 106 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->rename_utterance($_[2],$_[3]) }
	],
	[#Rule 42
		 'system_cmd', 2,
sub
#line 107 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->del_utterance($_[2]) }
	],
	[#Rule 43
		 'system_cmd', 2,
sub
#line 108 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->synth_utterance($_[2]) }
	],
	[#Rule 44
		 'system_cmd', 2,
sub
#line 109 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->save_utterance($_[2]) }
	],
	[#Rule 45
		 'system_cmd', 3,
sub
#line 110 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->save_utterance($_[2],$_[3]) }
	],
	[#Rule 46
		 'system_cmd', 4,
sub
#line 111 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->save_utterance($_[2],$_[3],$_[4]) }
	],
	[#Rule 47
		 'system_cmd', 2,
sub
#line 112 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->say_utterance($_[2]) }
	],
	[#Rule 48
		 'system_cmd', 1,
sub
#line 115 "SayWhat/Parser.yp"
{ print "Goodbye!\n"; exit(0); }
	],
	[#Rule 49
		 'config_list', 3,
sub
#line 126 "SayWhat/Parser.yp"
{ [$_[1],$_[3]] }
	],
	[#Rule 50
		 'config_list', 5,
sub
#line 127 "SayWhat/Parser.yp"
{
    #{%{$_[1]},$_[3]=>$_[5]}
    push(@{$_[1]},$_[3],$_[5]);
    $_[1];
  }
	],
	[#Rule 51
		 'id', 1, undef
	],
	[#Rule 52
		 'id', 1, undef
	],
	[#Rule 53
		 'nonterm', 1,
sub
#line 138 "SayWhat/Parser.yp"
{
    $_[0]->yywarn("not a nonterminal: `$_[1]'") 
      unless ($_[0]->YYData->{SayWhat}->is_nonterminal($_[1]));
    $_[1];
   }
	],
	[#Rule 54
		 'string', 1,
sub
#line 146 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->eval_string('"',$_[1]); }
	],
	[#Rule 55
		 'string', 1,
sub
#line 147 "SayWhat/Parser.yp"
{ $_[0]->YYData->{SayWhat}->eval_string("'",$_[1]); }
	],
	[#Rule 56
		 '@1-1', 0,
sub
#line 154 "SayWhat/Parser.yp"
{
              $_[0]->YYData->{perl_block_depth} = 0
		unless (exists $_[0]->YYData->{perl_block_depth});
              ++$_[0]->YYData->{perl_block_depth};
              $_[0]->YYData->{LexWrapper}->start('perlblock'); 
	    }
	],
	[#Rule 57
		 'perl_block', 4,
sub
#line 161 "SayWhat/Parser.yp"
{
	      --$_[0]->YYData->{perl_block_depth};
	      
	      # --- DEBUG ---
	      #print 
		#"perl_block($_[0]->{USER}->{perl_block_depth}):",
		#" read perl_block: \{ $_[3] \}\n"; 

	      $_[0]->YYData->{LexWrapper}->end('perlblock') 
		unless ($_[0]->YYData->{perl_block_depth} > 0);
	      '{'.$_[3].'}'
	    }
	],
	[#Rule 58
		 'block_body', 0, undef
	],
	[#Rule 59
		 'block_body', 2,
sub
#line 176 "SayWhat/Parser.yp"
{ 
    #print "block_body: read PERL_CODE: $_[1]\n";  # DEBUG
    $_[1].$_[2]
  }
	],
	[#Rule 60
		 'block_body', 2,
sub
#line 180 "SayWhat/Parser.yp"
{ $_[1].$_[2] }
	]
],
                                  @_);
    bless($self,$class);
}

#line 184 "SayWhat/Parser.yp"

# Footer section

1;
